// Datei: dotmatrix.c
// Ansteuerung eines 5x7 DotMatrix LED-Displays
//
// hk@holger-klabunde.de
// www.holger-klabunde.de
// 21.04.2002
// Compiler CC5x

#include "prozess.h"      // Der verwendete Prozessor
#include "dotmatrix.h"
#include "protos.h"

unsigned char charbuff[5]; //Puffer fr 5 Spalten Font
                           //man braucht nur diesen Puffer zu fllen,
                           //und die Ausgabe erfolgt automatisch per Interrupt

unsigned char colcount;    //Spaltenzhler

#include "int.c"
#include "delay.c"
#include "i2c.c"
 
//*******************************************************
// Hauptprogramm
//*******************************************************
void main()
{
 unsigned char i,count;
 
 CLRWDT;
 //Takt des PIC 4MHz, ein Zyklus = 1us
 OPTION=0b11000001; //Pullups off,Prescaler auf TMR0, 1:4

 ADCON0=0;          //AD-Wandler aus
 ADCON1=0x07;       //Alle Analogeingnge auf digital

 TRISB=0b00000000;  //0=Ausgang, 1=Eingang
 PORTB=0b00000000;  //Zeilentreiber aus

 TRISA=0b00000;     //0=Ausgang, 1=Eingang
 PORTA=0b11111;     //Spaltentreiber aus

 TRISC=0b11111111;   //PC7..0 Eingnge
 PORTC=0x00000000;

//I2C-Bus Modul einschalten
 SSPCON=0b00110110; //I2C-Slave Mode 7Bit
 SSPADD=0x7F; //I2C Adresse des Pic setzen auf die er antworten soll
 SSPSTAT=0b00000000;
 SSPCON2=0b00000000;

 T2CON=0b00000111;  //Prescaler TMR2 auf 1:16, ergibt Int alle 4ms. Optimal fr 50Hz Display
 TMR2IE=1;          //Timer2 Int an

 PEIE=1;            //Periphere Ints an
 GIE=1;             //Interrupts erlauben

 colcount=0;
  
 while(1) // Programm-Endlosschleife
  {
/*
   for(i=0; i<5; i++)
    {
     charbuff[i]=count;
    }
   Delay1ms(255);
   count++;
*/
    
   for(i=0x20; i<159; i++)
    {
     ReadChar(i);
     Delay1ms(250);
     Delay1ms(250);
     Delay1ms(250);
     Delay1ms(250);
    }

  } //while(1) Endlosschleife

}
